<!--
<new-api-group
  :editRow="editRow"
  :showDialog="showDialog"
  @hideDialog="hideDialog">
</new-api-group>

import newApiGroup from '@/components/program/new-api-group.vue'
 -->
<template>
  <div v-show="customDialog">
    <el-dialog class="edit-dialog" :title="formData.interfaceGroupId ? '编辑分组' : '新建分组'" :visible.sync="customDialog" width="600px" :before-close="handleClose">
      <div class="edit-dialog-body">
        <el-form :model="formData" label-width="94px" :rules="rules" ref="programGroupForm">
          <el-form-item label="分组名称:" prop="groupName">
            <limitInput :inputWidth="440" :inputValue.sync="formData.groupName" :holder="'请输入分组名称'" :getByType="'word'" :maxLength="20"> </limitInput>
          </el-form-item>
          <el-form-item label="描述:">
            <limit-textarea :inputWidth="440" :inputValue.sync="formData.remark" :holder="'请输入描述内容'" :getByType="'word'" :maxLength="100"> </limit-textarea>
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer" style="padding-bottom: 10px;">
        <el-button @click="customCancel">取 消</el-button>
        <el-button type="primary" @click="customConfirm('programGroupForm')">{{ formData.interfaceGroupId ? '保 存' : '新 建' }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import limitInput from '@/components/limit-input.vue';
import limitTextarea from '@/components/limit-textarea.vue';
import { getRequest } from '@/api/api';
import showMsg from '@/assets/js/showmsg';
import errMsg from '@/assets/js/error';
export default {
  name: 'new-api-group',
  props: {
    showDialog: {
      type: Boolean,
      default: false
    },
    editRow: {
      type: Object,
      default() {
        return {
          interfaceGroupId: '',
          groupName: '',
          remark: ''
        };
      }
    }
  },
  components: {
    limitInput,
    limitTextarea
  },
  data() {
    return {
      customDialog: false, // 弹框显示
      formData: {
        interfaceGroupId: '',
        groupName: '',
        remark: ''
      },
      rules: {
        groupName: [{ required: true, message: '请输入分组名称', trigger: 'blur' }],
        remark: [{ required: true, message: '请输入描述', trigger: 'blur' }]
      }
    };
  },
  methods: {
    /**
     *   关闭
     */
    handleClose(done) {
      const that = this;
      that.$refs['programGroupForm'].resetFields();
      done();
      that.hideDialog();
    },

    /**
     *  取消
     */
    customCancel() {
      const that = this;
      that.$refs['programGroupForm'].resetFields();
      that.hideDialog();
    },

    hideDialog() {
      const that = this;
      that.customDialog = false;
      that.formData.groupName = '';
      that.formData.remark = '';
      that.$emit('hideDialog', '');
      /* that.$nextTick(() => {
        that.formData.classifyName = '';
      }); */
    },

    /**
     *  确定
     */
    customConfirm(formName) {
      const that = this;
      that.formData.groupName = that.formData.groupName ? String(that.formData.groupName).replace(/\s+/g, '') : '';
      that.formData.remark = that.formData.remark ? String(that.formData.remark).replace(/\s+/g, '') : '';
      that.$refs[formName].validate(valid => {
        if (valid) {
          that.postEditData();
        } else {
          return false;
        }
      });
    },
    postEditData() {
      const that = this;
      let para = {
        interfaceGroupId: that.formData.interfaceGroupId,
        groupName: that.formData.groupName,
        remark: that.formData.remark,
        projectId: that.$route.query.projectId
      };
      getRequest(that.editRow.interfaceGroupId ? '/gateway-manage/update-api-group' : '/gateway-manage/create-api-group', para)
        .then(res => {
          let resData = res.data;
          if (resData.code == '0000') {
            showMsg.showmsg('保存成功', 'success');
            that.setData();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     *  提交数据
     */
    setData(list) {
      const that = this;
      that.$emit('hideDialog', that.formData);
      that.$nextTick(() => {
        that.formData.groupName = '';
        that.formData.remark = '';
      });
    }
  },
  watch: {
    showDialog: function(newData, oldData) {
      const that = this;
      that.customDialog = newData;
    },
    editRow: function(newData, oldData) {
      const that = this;
      if (Object.keys(newData).length) {
        that.formData = JSON.parse(JSON.stringify(newData));
      }
    }
  },

  /* 接收数据 */
  mounted() {
    const that = this;
    that.customDialog = that.showDialog;
    if (Object.keys(that.editRow).length) {
      that.formData = JSON.parse(JSON.stringify(that.editRow));
    }
  }
};
</script>

<style lang="less" scoped>
.edit-dialog {
  /deep/ .el-dialog__body {
    padding: 2px 55px 0 34px;
  }

  /deep/ .el-dialog__footer {
    border: none;
    padding-top: 3px;
  }

  &__title {
    width: 100%;
    height: 38px;
    padding: 12px 15px;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    background: rgba(235, 238, 245, 1);
  }

  .el-alert--info {
    width: 400px;
    font-size: 14px;
    color: #606266;
    background: #e6f7ff;
    border: 1px solid rgba(145, 213, 255, 1);
  }
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #1890ff;
  }
  .el-form {
    margin-top: 40px;
  }
}
</style>
